using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Herencia.Capas;
using Exferia_ControlGastos._0_Modelos;
using Exferia_EntityFramework;
using Exferia_General;
using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace Exferia_ControlGastos._1_Datos
{
    public class CTG_OrdenComisionServiciosGastos_Datos : ABS_Datos
    {
        #region Listados
        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region F3
        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region Obtener

        #region Obtener Simple
        private dynamic g_dnm_Modelo_Obtener = null;

        private static int g_int_TotalHilos_Obtener = 1;
        private bool[] g_bol_Hilos_Terminados_Obtener = new bool[g_int_TotalHilos_Obtener];

        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                         " SELECT " +
                             nameof(CTG_OrdenComisionServiciosGastos) + "." + nameof(CTG_OrdenComisionServiciosGastos.id) + "," +
                             nameof(CTG_OrdenComisionServiciosGastos) + "." + nameof(CTG_OrdenComisionServiciosGastos.idOrdenComisionServiciosCabecera) + "," +
                             nameof(CTG_OrdenComisionServiciosGastos) + "." + nameof(CTG_OrdenComisionServiciosGastos.idConcepto) + "," +
                             nameof(CTG_OrdenComisionServiciosGastos) + "." + nameof(CTG_OrdenComisionServiciosGastos.tipoDato) + "," +
                             nameof(CTG_OrdenComisionServiciosGastos) + "." + nameof(CTG_OrdenComisionServiciosGastos.valor) + "," +
                             nameof(CTG_OrdenComisionServiciosGastos) + "." + nameof(CTG_OrdenComisionServiciosGastos.fechaBorrado) +
                        " FROM " + nameof(CTG_OrdenComisionServiciosGastos) +
                        " WHERE  " + nameof(CTG_OrdenComisionServiciosGastos) + "." + nameof(CTG_OrdenComisionServiciosGastos.fechaBorrado) + " IS null AND " +
                                     nameof(CTG_OrdenComisionServiciosGastos) + "." + nameof(CTG_OrdenComisionServiciosGastos.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<CTG_OrdenComisionServiciosGastos>(str_SQL, arr_Parametros).FirstOrDefault();

                #region Rellenar tablas Relacionadas
                if (g_dnm_Modelo_Obtener != null)
                {
                    //reiniciar Valores de los hilos
                    for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Obtener; int_Contador++)
                    {
                        g_bol_Hilos_Terminados_Obtener[int_Contador] = false;
                    }

                    //CTG_Conceptos ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idConcepto != null)
                    {
                        ThreadStart obj_ThreadStart_CONCEPTO = new ThreadStart(Obtener_Concepto_Modelo_Obtener);
                        Thread obj_Thread_CONCEPTO = new Thread(obj_ThreadStart_CONCEPTO);
                        obj_Thread_CONCEPTO.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[0] = true;
                    }

                    //Esperando a que terminen todos los hilos .........................................
                    bool bol_Termino = false;
                    while (bol_Termino == false)
                    {
                        bol_Termino = true;
                        foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Obtener)
                        {
                            if (bol_Termino_Hilo == false)
                            {
                                bol_Termino = false;
                                break;
                            }
                        }

                        Thread.Sleep(10);
                    }
                    //.................................................................................
                }
                #endregion

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTG_OrdenComisionServiciosGastos_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }

        #region Tablas Relacionadas
        private void Obtener_Concepto_Modelo_Obtener()
        {
            try
            {
                CTG_Conceptos_Datos obj_CTG_Conceptos_Datos = new CTG_Conceptos_Datos();
                g_dnm_Modelo_Obtener.CTG_Conceptos = obj_CTG_Conceptos_Datos.Obtener_Modelo_Por_Id(g_dnm_Modelo_Obtener.idConcepto);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[0] = true;
            }
        }
        #endregion
        #endregion

        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }

        #region INTERNO MODELO LISTADO POR CABECERA
        List<INTERNO_CTG_OrdenComisionServiciosGastos_Listado_Modelo> g_lst_INTERNO_CTG_OrdenComisionServiciosGastos_Listado_Modelo_PORCABECERA = null;

        //Listado de modelos Relacionados
        private List<CTG_Conceptos> g_lst_CTG_Conceptos_PORCABECERA = null;

        //Hilos
        private static int g_int_TotalHilos_PORCABECERA = 1;
        private bool[] g_bol_Hilos_Terminados_PORCABECERA = new bool[g_int_TotalHilos_PORCABECERA];

        public List<INTERNO_CTG_OrdenComisionServiciosGastos_Listado_Modelo> Obtener_PorCabecera(long _lng_idOrdenComisionServicioCabecera)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                        " SELECT " +
                            nameof(INTERNO_CTG_OrdenComisionServiciosGastos_Listado_Modelo.id) + "=" + nameof(CTG_OrdenComisionServiciosGastos) + "." + nameof(CTG_OrdenComisionServiciosGastos.id) + "," +
                            nameof(INTERNO_CTG_OrdenComisionServiciosGastos_Listado_Modelo.tipoDato) + "=" + nameof(CTG_OrdenComisionServiciosGastos) + "." + nameof(CTG_OrdenComisionServiciosGastos.tipoDato) + "," +
                            nameof(INTERNO_CTG_OrdenComisionServiciosGastos_Listado_Modelo.valor) + "=" + nameof(CTG_OrdenComisionServiciosGastos) + "." + nameof(CTG_OrdenComisionServiciosGastos.valor) + "," +
                            nameof(INTERNO_CTG_OrdenComisionServiciosGastos_Listado_Modelo.fechaBorrado) + "=" + nameof(CTG_OrdenComisionServiciosGastos) + "." + nameof(CTG_OrdenComisionServiciosGastos.fechaBorrado) + "," +
                            //ids
                            nameof(INTERNO_CTG_OrdenComisionServiciosGastos_Listado_Modelo.idOrdenComisionServiciosCabecera) + "=" + nameof(CTG_OrdenComisionServiciosGastos) + "." + nameof(CTG_OrdenComisionServiciosGastos.idOrdenComisionServiciosCabecera) + "," +
                            nameof(INTERNO_CTG_OrdenComisionServiciosGastos_Listado_Modelo.idConcepto) + "=" + nameof(CTG_OrdenComisionServiciosGastos) + "." + nameof(CTG_OrdenComisionServiciosGastos.idConcepto) +
                       " FROM " + nameof(CTG_OrdenComisionServiciosGastos) +
                       " WHERE  " + nameof(CTG_OrdenComisionServiciosGastos) + "." + nameof(CTG_OrdenComisionServiciosGastos.fechaBorrado) + " IS null AND " +
                                    nameof(CTG_OrdenComisionServiciosGastos) + "." + nameof(CTG_OrdenComisionServiciosGastos.idOrdenComisionServiciosCabecera) + "=@idOrdenComisionServiciosCabecera ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idOrdenComisionServiciosCabecera",  _lng_idOrdenComisionServicioCabecera)
                };

                //Rellenar el Modelo
                g_lst_INTERNO_CTG_OrdenComisionServiciosGastos_Listado_Modelo_PORCABECERA = obj_Exferia_Entities.Database.SqlQuery<INTERNO_CTG_OrdenComisionServiciosGastos_Listado_Modelo>(str_SQL, arr_Parametros).ToList();


                #region Rellenar Tablas Relacionadas
                if (g_lst_INTERNO_CTG_OrdenComisionServiciosGastos_Listado_Modelo_PORCABECERA != null &&
                   g_lst_INTERNO_CTG_OrdenComisionServiciosGastos_Listado_Modelo_PORCABECERA.Count > 0)
                {
                    #region PRIMERO BUSCO LOS DATOS DE LAS TABLAS RELACIONADAS
                    //reiniciar Valores de los hilos
                    for (int int_Contador = 0; int_Contador < g_int_TotalHilos_PORCABECERA; int_Contador++)
                    {
                        g_bol_Hilos_Terminados_PORCABECERA[int_Contador] = false;
                    }

                    //CTG_Conceptos #######################################################
                    ThreadStart obj_ThreadStart_CONCEPTO = new ThreadStart(Obtener_CONCEPTO_Modelo_Obtener_PORCABECERA);
                    Thread obj_Thread_CONCEPTO = new Thread(obj_ThreadStart_CONCEPTO);
                    obj_Thread_CONCEPTO.Start();

                    //Esperando a que terminen todos los hilos .........................................
                    bool bol_Termino = false;
                    while (bol_Termino == false)
                    {
                        bol_Termino = true;
                        foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_PORCABECERA)
                        {
                            if (bol_Termino_Hilo == false)
                            {
                                bol_Termino = false;
                                break;
                            }
                        }

                        Thread.Sleep(10);
                    }
                    //.................................................................................

                    #endregion

                    #region DESPUES SE LO VOY ASIGNANDO A LOS REGISTRO UNO A UNO
                    foreach (INTERNO_CTG_OrdenComisionServiciosGastos_Listado_Modelo mdl_INTERNO_CTG_OrdenComisionServiciosGastos_Listado_Modelo in g_lst_INTERNO_CTG_OrdenComisionServiciosGastos_Listado_Modelo_PORCABECERA)
                    {
                        //CTG_Conceptos #############################################
                        if (g_lst_CTG_Conceptos_PORCABECERA != null &&
                            g_lst_CTG_Conceptos_PORCABECERA.Count > 0)
                        {
                            mdl_INTERNO_CTG_OrdenComisionServiciosGastos_Listado_Modelo.CTG_Conceptos = g_lst_CTG_Conceptos_PORCABECERA.Where(m => m.id == mdl_INTERNO_CTG_OrdenComisionServiciosGastos_Listado_Modelo.idConcepto).FirstOrDefault();
                        }
                    }
                    #endregion
                }
                #endregion

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTG_OrdenComisionServiciosGastos_Datos) + "/" + nameof(Obtener_PorCabecera), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_lst_INTERNO_CTG_OrdenComisionServiciosGastos_Listado_Modelo_PORCABECERA;
        }

        #region Tablas Relacionadas
        private void Obtener_CONCEPTO_Modelo_Obtener_PORCABECERA()
        {
            try
            {
                CTG_Conceptos_Datos obj_CTG_Conceptos_Datos = new CTG_Conceptos_Datos();
                g_lst_CTG_Conceptos_PORCABECERA = obj_CTG_Conceptos_Datos.Obtener_ModeloListado_Por_Ids(g_lst_INTERNO_CTG_OrdenComisionServiciosGastos_Listado_Modelo_PORCABECERA.Select(x => x.idConcepto).ToList());
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_PORCABECERA[0] = true;
            }
        }
        #endregion

        #endregion

        #region OBTENER PARA LISTADO
        INTERNO_CTG_OrdenComisionServiciosGastos_Listado_Modelo g_mdl_INTERNO_CTG_OrdenComisionServiciosGastos_Listado_Modelo_PARALISTADO = null;

        private static int g_int_TotalHilos_PARALISTADO = 1;
        private bool[] g_bol_Hilos_Terminados_PARALISTADO = new bool[g_int_TotalHilos_PARALISTADO];

        public INTERNO_CTG_OrdenComisionServiciosGastos_Listado_Modelo Obtener_ParaListado(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                        " SELECT " +
                            nameof(INTERNO_CTG_OrdenComisionServiciosGastos_Listado_Modelo.id) + "=" + nameof(CTG_OrdenComisionServiciosGastos) + "." + nameof(CTG_OrdenComisionServiciosGastos.id) + "," +
                            nameof(INTERNO_CTG_OrdenComisionServiciosGastos_Listado_Modelo.tipoDato) + "=" + nameof(CTG_OrdenComisionServiciosGastos) + "." + nameof(CTG_OrdenComisionServiciosGastos.tipoDato) + "," +
                            nameof(INTERNO_CTG_OrdenComisionServiciosGastos_Listado_Modelo.valor) + "=" + nameof(CTG_OrdenComisionServiciosGastos) + "." + nameof(CTG_OrdenComisionServiciosGastos.valor) + "," +
                            nameof(INTERNO_CTG_OrdenComisionServiciosGastos_Listado_Modelo.fechaBorrado) + "=" + nameof(CTG_OrdenComisionServiciosGastos) + "." + nameof(CTG_OrdenComisionServiciosGastos.fechaBorrado) + "," +
                            //ids
                            nameof(INTERNO_CTG_OrdenComisionServiciosGastos_Listado_Modelo.idOrdenComisionServiciosCabecera) + "=" + nameof(CTG_OrdenComisionServiciosGastos) + "." + nameof(CTG_OrdenComisionServiciosGastos.idOrdenComisionServiciosCabecera) + "," +
                            nameof(INTERNO_CTG_OrdenComisionServiciosGastos_Listado_Modelo.idConcepto) + "=" + nameof(CTG_OrdenComisionServiciosGastos) + "." + nameof(CTG_OrdenComisionServiciosGastos.idConcepto) +
                       " FROM " + nameof(CTG_OrdenComisionServiciosGastos) +
                       " WHERE  " + nameof(CTG_OrdenComisionServiciosGastos) + "." + nameof(CTG_OrdenComisionServiciosGastos.fechaBorrado) + " IS null AND " +
                                    nameof(CTG_OrdenComisionServiciosGastos) + "." + nameof(CTG_OrdenComisionServiciosGastos.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_mdl_INTERNO_CTG_OrdenComisionServiciosGastos_Listado_Modelo_PARALISTADO = obj_Exferia_Entities.Database.SqlQuery<INTERNO_CTG_OrdenComisionServiciosGastos_Listado_Modelo>(str_SQL, arr_Parametros).FirstOrDefault();

                #region Rellenar Tablas Relacionadas
                if (g_mdl_INTERNO_CTG_OrdenComisionServiciosGastos_Listado_Modelo_PARALISTADO != null)
                {
                    //reiniciar Valores de los hilos
                    for (int int_Contador = 0; int_Contador < g_int_TotalHilos_PARALISTADO; int_Contador++)
                    {
                        g_bol_Hilos_Terminados_PARALISTADO[int_Contador] = false;
                    }

                    //CTG_Conceptos ##########################################################################################
                    ThreadStart obj_ThreadStart_CONCEPTO = new ThreadStart(Obtener_Concepto_Modelo_PARALISTADO);
                    Thread obj_Thread_CONCEPTO = new Thread(obj_ThreadStart_CONCEPTO);
                    obj_Thread_CONCEPTO.Start();

                    //Esperando a que terminen todos los hilos .........................................
                    bool bol_Termino = false;
                    while (bol_Termino == false)
                    {
                        bol_Termino = true;
                        foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_PARALISTADO)
                        {
                            if (bol_Termino_Hilo == false)
                            {
                                bol_Termino = false;
                                break;
                            }
                        }

                        Thread.Sleep(10);
                    }
                    //.................................................................................
                }
                #endregion

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTG_OrdenComisionServiciosGastos_Datos) + "/" + nameof(Obtener_ParaListado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_mdl_INTERNO_CTG_OrdenComisionServiciosGastos_Listado_Modelo_PARALISTADO;
        }

        #region Tablas Relacionadas
        private void Obtener_Concepto_Modelo_PARALISTADO()
        {
            try
            {
                CTG_Conceptos_Datos obj_CTG_Conceptos_Datos = new CTG_Conceptos_Datos();
                g_mdl_INTERNO_CTG_OrdenComisionServiciosGastos_Listado_Modelo_PARALISTADO.CTG_Conceptos = obj_CTG_Conceptos_Datos.Obtener_Modelo_Por_Id(g_mdl_INTERNO_CTG_OrdenComisionServiciosGastos_Listado_Modelo_PARALISTADO.idConcepto);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_PARALISTADO[0] = true;
            }
        }
        #endregion

        #endregion

        #endregion

        #region MODELOS

        #region Modelo Simple
        private CTG_OrdenComisionServiciosGastos g_mdl_CTG_OrdenComisionServiciosGastos = null;

        public CTG_OrdenComisionServiciosGastos Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                      //WHERE
                                      " WHERE " + nameof(CTG_OrdenComisionServiciosGastos) + "." + nameof(CTG_OrdenComisionServiciosGastos.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTG_OrdenComisionServiciosGastos_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_CTG_OrdenComisionServiciosGastos;
        }

        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                              object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_mdl_CTG_OrdenComisionServiciosGastos = obj_Exferia_Entities.Database.SqlQuery<CTG_OrdenComisionServiciosGastos>(_str_SQL, _arr_Parametros).FirstOrDefault();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTG_OrdenComisionServiciosGastos_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                    nameof(CTG_OrdenComisionServiciosGastos.id) + "," +
                    nameof(CTG_OrdenComisionServiciosGastos.idOrdenComisionServiciosCabecera) + "," +
                    nameof(CTG_OrdenComisionServiciosGastos.idConcepto) + "," +
                    nameof(CTG_OrdenComisionServiciosGastos.tipoDato) + "," +
                    nameof(CTG_OrdenComisionServiciosGastos.valor) + "," +
                    nameof(CTG_OrdenComisionServiciosGastos.fechaBorrado) +
                " FROM " + nameof(CTG_OrdenComisionServiciosGastos);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                CTG_OrdenComisionServiciosGastos mdl_CTG_OrdenComisionServiciosGastos_AGrabar = (CTG_OrdenComisionServiciosGastos)_mdl_obj;
                CTG_OrdenComisionServiciosGastos mdl_CTG_OrdenComisionServiciosGastos_DatosViejos = new CTG_OrdenComisionServiciosGastos();

                // Ver si existe ######################################################################
                CTG_OrdenComisionServiciosGastos mdl_CTG_OrdenComisionServiciosGastos_Final = Obtener_Modelo_Por_Id(mdl_CTG_OrdenComisionServiciosGastos_AGrabar.id);
                //######################################################################################

                //UPDATE
                if (mdl_CTG_OrdenComisionServiciosGastos_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_CTG_OrdenComisionServiciosGastos_Final, mdl_CTG_OrdenComisionServiciosGastos_DatosViejos, false, false);

                    // Cargar los Datos Nuevos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_CTG_OrdenComisionServiciosGastos_AGrabar, mdl_CTG_OrdenComisionServiciosGastos_Final, false, false);

                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(CTG_OrdenComisionServiciosGastos) +
                                           " SET " +
                                               nameof(CTG_OrdenComisionServiciosGastos.idOrdenComisionServiciosCabecera) + "=@idOrdenComisionServiciosCabecera," +
                                               nameof(CTG_OrdenComisionServiciosGastos.idConcepto) + "=@idConcepto," +
                                               nameof(CTG_OrdenComisionServiciosGastos.tipoDato) + "=@tipoDato," +
                                               nameof(CTG_OrdenComisionServiciosGastos.valor) + "=@valor," +
                                               nameof(CTG_OrdenComisionServiciosGastos.fechaBorrado) + "=@fechaBorrado" +
                                           " WHERE " +
                                               nameof(CTG_OrdenComisionServiciosGastos.id) + "=@id";

                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                         new SqlParameter("@idOrdenComisionServiciosCabecera",  mdl_CTG_OrdenComisionServiciosGastos_Final.idOrdenComisionServiciosCabecera),
                         new SqlParameter("@idConcepto",  mdl_CTG_OrdenComisionServiciosGastos_Final.idConcepto),
                         new SqlParameter("@tipoDato",  mdl_CTG_OrdenComisionServiciosGastos_Final.tipoDato),
                         new SqlParameter("@valor",  mdl_CTG_OrdenComisionServiciosGastos_Final.valor),
                         mdl_CTG_OrdenComisionServiciosGastos_Final.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_CTG_OrdenComisionServiciosGastos_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                         new SqlParameter("@id",  mdl_CTG_OrdenComisionServiciosGastos_Final.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_CTG_OrdenComisionServiciosGastos_Final.id;
                }
                //INSERT
                else
                {
                    mdl_CTG_OrdenComisionServiciosGastos_Final = new CTG_OrdenComisionServiciosGastos();

                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_INSERTAR;

                    // Cargar los Datos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_CTG_OrdenComisionServiciosGastos_AGrabar, mdl_CTG_OrdenComisionServiciosGastos_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(CTG_OrdenComisionServiciosGastos) +
                                              " (" +
                                                      nameof(CTG_OrdenComisionServiciosGastos.idOrdenComisionServiciosCabecera) + "," +
                                                      nameof(CTG_OrdenComisionServiciosGastos.idConcepto) + "," +
                                                      nameof(CTG_OrdenComisionServiciosGastos.tipoDato) + "," +
                                                      nameof(CTG_OrdenComisionServiciosGastos.valor) + "," +
                                                      nameof(CTG_OrdenComisionServiciosGastos.fechaBorrado) +
                                              " ) " +
                                              " OUTPUT INSERTED." + nameof(CTG_OrdenComisionServiciosGastos.id) +
                                              " VALUES " +
                                              " ( " +
                                                  "@idOrdenComisionServiciosCabecera," +
                                                  "@idConcepto," +
                                                  "@tipoDato," +
                                                  "@valor," +
                                                  "@fechaBorrado" +
                                              " ) ";

                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@idOrdenComisionServiciosCabecera",  mdl_CTG_OrdenComisionServiciosGastos_Final.idOrdenComisionServiciosCabecera),
                        new SqlParameter("@idConcepto",  mdl_CTG_OrdenComisionServiciosGastos_Final.idConcepto),
                        new SqlParameter("@tipoDato",  mdl_CTG_OrdenComisionServiciosGastos_Final.tipoDato),
                        new SqlParameter("@valor",  mdl_CTG_OrdenComisionServiciosGastos_Final.valor),
                        mdl_CTG_OrdenComisionServiciosGastos_Final.fechaBorrado!=null
                           ?   new SqlParameter("@fechaBorrado", mdl_CTG_OrdenComisionServiciosGastos_Final.fechaBorrado.Value)
                           :   new SqlParameter("@fechaBorrado",  DBNull.Value)
                    };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(CTG_OrdenComisionServiciosGastos), mdl_CTG_OrdenComisionServiciosGastos_DatosViejos, mdl_CTG_OrdenComisionServiciosGastos_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTG_OrdenComisionServiciosGastos_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                //Finalizar transaccion
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;
            //Tipo de Accion que se va a realizar
            mdl_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Ver si existe ######################################################################
                CTG_OrdenComisionServiciosGastos mdl_CTG_OrdenComisionServiciosGastos_Final = Obtener_Modelo_Por_Id(_lng_id);
                //######################################################################################

                if (mdl_CTG_OrdenComisionServiciosGastos_Final != null)
                {
                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(CTG_OrdenComisionServiciosGastos) +
                                                " SET " +
                                                nameof(CTG_OrdenComisionServiciosGastos.fechaBorrado) + "=@fechaBorrado " +
                                            " WHERE " +
                                                nameof(CTG_OrdenComisionServiciosGastos.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@fechaBorrado",  DateTime.Now),
                        new SqlParameter("@id", _lng_id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Grabar un registro de trazabilidad con los datos de la transaccion realizada
                    Datos_Generales.USR_Trazabilidad_Grabar(typeof(CTG_OrdenComisionServiciosGastos), null, mdl_CTG_OrdenComisionServiciosGastos_Final, Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                }

                //Devolver tambien el Objeto
                mdl_ValorDevuelto_Modelo.Id = _lng_id;
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTG_OrdenComisionServiciosGastos_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                List<long> lst_idOrdenComisionServicioLinea = (List<long>)_mdl_obj;

                if (lst_idOrdenComisionServicioLinea != null & lst_idOrdenComisionServicioLinea.Count > 0)
                {
                    DateTime dtt_FechaActual = DateTime.Now;

                    //Coger los ids y ponerlos de forma que sirva para la consulta
                    string str_Filtros_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(lst_idOrdenComisionServicioLinea);

                    string str_SQL = " UPDATE " + nameof(CTG_OrdenComisionServiciosGastos) +
                                        " SET " + nameof(CTG_OrdenComisionServiciosGastos.fechaBorrado) + "='" + dtt_FechaActual + "' " +
                                     " WHERE " + nameof(CTG_OrdenComisionServiciosGastos.id) + " in (" + str_Filtros_IDS + ")";

                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL);
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTG_OrdenComisionServiciosGastos_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        #endregion

    }
}
